{{- if .Values.enabled -}}
apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ template "registry.fullname" . }}
  namespace: {{ $.Release.Namespace }}
  labels:
    {{- include "gitlab.standardLabels" . | nindent 4 }}
    {{- include "gitlab.commonLabels" . | nindent 4 }}
data:
  configure: |-
    {{- .Values.init.script | nindent 4 }}
  config.yml: |
    version: 0.1
    log:
      {{ toYaml .Values.log | nindent 6 | trim }}
    http:
      addr: :{{ .Values.service.internalPort }}
      # `host` is not configurable
      # `prefix` is not configurable
      {{- if .Values.tls.enabled }}
      tls:
        certificate: /etc/docker/registry/tls/tls.crt
        key: /etc/docker/registry/tls/tls.key
        {{- if kindIs "slice" .Values.tls.clientCAs }}
        clientCAs: {{ toYaml .Values.tls.clientCAs | nindent 10 }}
        {{- end }}
        minimumTLS: {{ default "tls1.2" .Values.tls.minimumTLS | quote }}
      {{- end }}
      {{- if .Values.debug }}
      debug:
        addr: ':{{ .Values.debug.addr.port | int }}'
        prometheus:
          enabled: {{ (or .Values.metrics.enabled .Values.debug.prometheus.enabled) }}
          path: {{ default .Values.metrics.path .Values.debug.prometheus.path }}
      {{- end }}
      draintimeout: {{ .Values.draintimeout }}
      headers:
        X-Content-Type-Options: [nosniff]
      secret: "HTTP_SECRET"
      relativeurls: {{ .Values.relativeurls }}
    health:
      {{- if kindIs "map" .Values.health }}
      {{ toYaml .Values.health | nindent 6 | trim }}
      {{- end }}
    auth:
      token:
        realm: {{ template "registry.authEndpoint" . }}/jwt/auth
        service: {{ .Values.tokenService }}
        issuer: {{ .Values.tokenIssuer | quote }}
        # This is provided from the initContainer execution, at a known path.
        rootcertbundle: /etc/docker/registry/certificate.crt
        autoredirect: {{ .Values.authAutoRedirect }}
    {{- if .Values.compatibility }}
    compatibility:
      {{- if .Values.compatibility.schema1 }}
      schema1:
        enabled: {{ eq true .Values.compatibility.schema1.enabled }}
      {{- end }}
    {{- end }}
    validation:
      disabled: {{ eq true .Values.validation.disabled }}
      {{- with .Values.validation.manifests }}
      manifests:
        referencelimit: {{ .referencelimit }}
        payloadsizelimit: {{ .payloadsizelimit }}
        urls:
          allow:
        {{- range .urls.allow }}
          - {{ . }}
        {{- end }}
          deny:
        {{- range .urls.deny }}
          - {{ . }}
        {{- end }}
      {{- end }}
    {{- include "registry.notifications.config" $ | nindent 4 }}
    reporting:
      {{- if .Values.reporting.sentry.enabled }}
      sentry:
        enabled: true
        dsn: {{ .Values.reporting.sentry.dsn }}
        {{- if .Values.reporting.sentry.environment }}
        environment: {{ .Values.reporting.sentry.environment }}
        {{- end }}
      {{- end }}
    profiling:
      {{- if .Values.profiling.stackdriver.enabled }}
      stackdriver:
        enabled: true
        service: {{ template "gitlab.registry.profiling.stackdriver.service" . }}
        serviceversion: {{ .Values.image.tag }}
        {{- if .Values.profiling.stackdriver.projectid }}
        projectid: {{ .Values.profiling.stackdriver.projectid }}
        {{- end }}
        {{- if .Values.profiling.stackdriver.credentials.secret }}
        keyfile: /etc/docker/registry/profiling-key.json
        {{- end }}
      {{- end }}
    storage:
      maintenance:
        readonly:
          enabled: {{ .Values.maintenance.readonly.enabled }}
        uploadpurging:
          enabled: {{ .Values.maintenance.uploadpurging.enabled }}
          age: {{ .Values.maintenance.uploadpurging.age }}
          interval: {{ .Values.maintenance.uploadpurging.interval }}
          dryrun: {{ .Values.maintenance.uploadpurging.dryrun }}
      {{- if .Values.storage }}
      {{- with .Values.storage.redirect }}
      redirect:
        disable: {{ default false .disable }}
        exceptions:
        {{- range .exceptions }}
          - {{ . }}
        {{- end }}
      {{- end }}
      {{- else if .Values.global.minio.enabled }}
      s3:
        accesskey: "ACCESS_KEY"
        secretkey: "SECRET_KEY"
        region: us-east-1
        regionendpoint: {{ template "registry.minio.url" . }}
        bucket: {{ coalesce .Values.minio.bucket .Values.global.registry.bucket }}
        secure: true
        v4auth: true
        rootdirectory: /
      cache:
        blobdescriptor: 'inmemory'
      delete:
        enabled: true
      {{- if not .Values.minio.redirect }}
      redirect:
        disable: true
      {{- end }}
      {{- else }}
      {{- include (print $.Template.BasePath "/_storage_default.yaml") . | nindent 6}}
      {{- end }}
    middleware:
    {{- if .Values.middleware.storage }}
      storage:
      {{ range $index, $v := .Values.middleware.storage }}
      - name: {{ $v.name }}
        options: {{ omit $v.options "privatekeySecret" "privatekey" | toYaml | nindent 10 }}
          privatekey: {{ printf "/etc/docker/registry/middleware.storage/%d/%s" $index $v.options.privatekeySecret.key }}
      {{ end }}
    {{- end }}
    {{- include "registry.database.config" $ | nindent 4 }}
    {{- include "registry.gc.config" $ | nindent 4 }}
    {{- include "registry.migration.config" $ | nindent 4 }}

  # minimal configuration, in order to do database migrations
  migrations-config.yml: |
    version: 0.1
    log:
      {{ toYaml .Values.log | nindent 6 | trim }}
    {{- include "registry.database.config" $ | nindent 4 }}
{{- end -}}
